package fr.doap.jdb.impl;

import fr.doap.slog.*;

import java.lang.reflect.*;

interface PropGetterSetter {
	
	Class<?> getType();
	
	Object get(Object aObject);
	void set(Object aObject, Object aValue);
	
	
	static public class FieldGS implements PropGetterSetter {
		FieldGS(Field aF) { mField=aF; }
		
		public Class<?> getType() { return mField.getType(); }
		
		public Object get(Object aObject) { try { return mField.get(aObject); } catch (Exception aE) { L.t(aE); } return null; }
		public void set(Object aObject, Object aValue) { try { mField.set(aObject, aValue); } catch (Exception aE) { L.t(aE); }}
		
		Field mField;
	}
}
