package fr.doap.slog;

import org.slf4j.*;

public class L {
	static public void e(String aS) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isErrorEnabled()) lLogger.error(formatLog(lSTE, aS));
	}
	
	static public void e(Throwable aThrowable) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isErrorEnabled()) lLogger.error(formatLog(lSTE, aThrowable.getLocalizedMessage()), aThrowable);
	}
	
	static public void e(String aS, Object ... aArgs) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isErrorEnabled()) lLogger.error(formatLog(lSTE, aS), aArgs);
	}
	
	static public void w(String aS) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isWarnEnabled()) lLogger.warn(formatLog(lSTE, aS));
	}
	
	static public void w(Throwable aThrowable) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isWarnEnabled()) lLogger.warn(formatLog(lSTE, aThrowable.getLocalizedMessage()), aThrowable);
	}
	
	static public void w(String aS, Object ... aArgs) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isWarnEnabled()) lLogger.warn(formatLog(lSTE, aS), aArgs);
	}
	
	static public void i(String aS) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isInfoEnabled()) lLogger.info(formatLog(lSTE, aS));
	}
	
	static public void i(Throwable aThrowable) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isInfoEnabled()) lLogger.info(formatLog(lSTE, aThrowable.getLocalizedMessage()), aThrowable);
	}

	static public void i(String aS, Object ... aArgs) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isInfoEnabled()) lLogger.info(formatLog(lSTE, aS), aArgs);
	}
	
	static public void d(String aS) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isDebugEnabled()) lLogger.debug(formatLog(lSTE, aS));
	}
	
	static public void d(Throwable aThrowable) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isDebugEnabled()) lLogger.debug(formatLog(lSTE, aThrowable.getLocalizedMessage()), aThrowable);
	}
	
	static public void d(String aS, Object ... aArgs) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isDebugEnabled()) lLogger.debug(formatLog(lSTE, aS), aArgs);
	}
	
	static public void t(String aS) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isTraceEnabled()) lLogger.trace(formatLog(lSTE, aS));
	}
	
	static public void t(Throwable aThrowable) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isTraceEnabled()) lLogger.trace(formatLog(lSTE, aThrowable.getLocalizedMessage()), aThrowable);
	}
	
	static public void t(String aS, Object ... aArgs) {
		StackTraceElement lSTE = getCaller();
		Logger lLogger = LoggerFactory.getLogger(lSTE.getClassName());
		if (lLogger.isTraceEnabled()) lLogger.trace(formatLog(lSTE, aS), aArgs);
	}
	
	static StackTraceElement getCaller() {
		StackTraceElement[] lSTEs = Thread.currentThread().getStackTrace();
		int lPos = 1;
		while (lSTEs[lPos].getClassName().startsWith("fr.doap.slog.L")) lPos++;
		return lSTEs[lPos];
	}
	
	static String formatLog(StackTraceElement aSTE, String aS) {
		return aSTE.getMethodName()+": "+aS+" ("+aSTE.getFileName()+":"+aSTE.getLineNumber()+")";
	}
}
