package fr.doap.jdb;

import fr.doap.slog.*;
import org.junit.jupiter.api.*;

import java.util.*;

@TestMethodOrder(MethodOrderer.MethodName.class)
public class JDBTest {
	
	@BeforeAll
	static void setUp() {
		JDB.init("jdbc:h2:~/test2", "sa", "");
	}
	
	@Test
	public void test1() {
		JDB.save(new TestC2());
		JDB.save(new TestC());
		JDB.save(new TestD());
		
		JDB.sJDB.mWeakObjectCache.clear();
		
		JDB.sJDB.mDBWrap.query("SELECT * FROM OBJECTS").forEach(aMap -> L.i(aMap.toString()));
		
		L.i("Iterating...");
		Iterator<TestC> iIT = JDB.sJDB._query(TestC.class);

		while (iIT.hasNext()) {
			TestC lTC = iIT.next();
		}
	}
	
	
	@AfterAll
	static void closeUp() {
		JDB.sJDB.mDBWrap.exec("DROP ALL OBJECTS DELETE FILES");
	}
}
